# class Bundler::StubSpecification

### Attributes

ignored[RW]
stub[RW]

### Public Class Methods

from_stub(stub) click to toggle source

    # File lib/bundler/stub_specification.rb, line 7
    def self.from_stub(stub)
      return stub if stub.is_a?(Bundler::StubSpecification)
      spec = new(stub.name, stub.version, stub.platform, nil)
      spec.stub = stub
      spec
    end

### Public Instance Methods

activated() click to toggle source

    # File lib/bundler/stub_specification.rb, line 42
    def activated
      stub.activated
    end

activated=(activated) click to toggle source

    # File lib/bundler/stub_specification.rb, line 46
    def activated=(activated)
      stub.instance_variable_set(:@activated, activated)
    end

default_gem() click to toggle source

    # File lib/bundler/stub_specification.rb, line 50
    def default_gem
      stub.default_gem
    end

full_gem_path() click to toggle source

    # File lib/bundler/stub_specification.rb, line 54
    def full_gem_path
      # deleted gems can have their stubs return nil, so in that case grab the
      # expired path from the full spec
      stub.full_gem_path || method_missing(:full_gem_path)
    end

full_require_paths() click to toggle source

    # File lib/bundler/stub_specification.rb, line 61
    def full_require_paths
      stub.full_require_paths
    end

load_paths() click to toggle source

This is what we do in bundler/rubygems_ext `full_require_paths` is always implemented in >= 2.2.0

    # File lib/bundler/stub_specification.rb, line 67
    def load_paths
      full_require_paths
    end

loaded_from() click to toggle source

    # File lib/bundler/stub_specification.rb, line 72
    def loaded_from
      stub.loaded_from
    end

matches_for_glob(glob) click to toggle source

    # File lib/bundler/stub_specification.rb, line 77
    def matches_for_glob(glob)
      stub.matches_for_glob(glob)
    end

missing_extensions?() click to toggle source

This is defined directly to avoid having to load every installed spec

    # File lib/bundler/stub_specification.rb, line 37
    def missing_extensions?
      stub.missing_extensions?
    end

raw_require_paths() click to toggle source

    # File lib/bundler/stub_specification.rb, line 82
    def raw_require_paths
      stub.raw_require_paths
    end

source=(source) click to toggle source
Calls superclass method

    # File lib/bundler/stub_specification.rb, line 19
    def source=(source)
      super
      # Stub has no concept of source, which means that extension_dir may be wrong
      # This is the case for git-based gems. So, instead manually assign the extension dir
      return unless source.respond_to?(:extension_dir_name)
      path = File.join(stub.extensions_dir, source.extension_dir_name)
      stub.extension_dir = File.expand_path(path)
    end

to_yaml() click to toggle source

    # File lib/bundler/stub_specification.rb, line 29
    def to_yaml
      _remote_specification.to_yaml
    end

### Private Instance Methods

_remote_specification() click to toggle source

    # File lib/bundler/stub_specification.rb, line 88
    def _remote_specification
      @_remote_specification ||= begin
        rs = stub.to_spec
        if rs.equal?(self) # happens when to_spec gets the spec from Gem.loaded_specs
          rs = Gem::Specification.load(loaded_from)
          Bundler.rubygems.stub_set_spec(stub, rs)
        end

        unless rs
          raise GemspecError, "The gemspec for #{full_name} at #{loaded_from}" \
            " was missing or broken. Try running `gem pristine #{name} -v #{version}`" \
            " to fix the cached spec."
        end

        rs.source = source

        rs
      end
    end